## org.jdom
Class DocType

    java.lang.Object
      |
      +--org.jdom.DocType

public class DocType
extends java.lang.Object
implements java.io.Serializable, java.lang.Cloneable

`DocType` represents an XML DOCTYPE declaration.

Version:
  $Revision: 1.18 $, $Date: 2002/02/05 08:03:18 $
Author:
  Brett McLaughlin, Jason Hunter
See Also:
  Serialized Form

Field Summary
`protected Document` `document` The document having this DOCTYPE
`protected java.lang.String` `elementName` The element being constrained
`protected java.lang.String` `internalSubset` The internal subset of the DOCTYPE
`protected java.lang.String` `publicID` The public ID of the DOCTYPE
`protected java.lang.String` `systemID` The system ID of the DOCTYPE

Constructor Summary
`protected` `DocType()` Default, no-args constructor for implementations to use if needed.
`` `DocType(java.lang.String elementName)` This will create the `DocType` with the specified element name
`` `DocType(java.lang.String elementName, java.lang.String systemID)` This will create the `DocType` with the specified element name and reference to an external DTD.
`` `DocType(java.lang.String elementName, java.lang.String publicID, java.lang.String systemID)` This will create the `DocType` with the specified element name and a reference to an external DTD.

Method Summary
`java.lang.Object` `clone()` This will return a clone of this `DocType`.
`boolean` `equals(java.lang.Object ob)` This tests for equality of this `DocType` to the supplied `Object`.
`Document` `getDocument()` This retrieves the owning ``Document`` for this DocType, or null if not a currently a member of a ``Document``.
`java.lang.String` `getElementName()` This will retrieve the element name being constrained.
`java.lang.String` `getInternalSubset()` This returns the data for the internal subset
`java.lang.String` `getPublicID()` This will retrieve the public ID of an externally referenced DTD, or an empty `String` if none is referenced.
`java.lang.String` `getSystemID()` This will retrieve the system ID of an externally referenced DTD, or an empty `String` if none is referenced.
`int` `hashCode()` This returns the hash code for this `DocType`.
`protected DocType` `setDocument(Document document)` This sets the ``Document`` holding this doctype.
`DocType` `setElementName(java.lang.String elementName)` This will set the root element name declared by this DOCTYPE declaration.
`void` `setInternalSubset(java.lang.String newData)` This sets the data for the internal subset.
`DocType` `setPublicID(java.lang.String publicID)` This will set the public ID of an externally referenced DTD.
`DocType` `setSystemID(java.lang.String systemID)` This will set the system ID of an externally referenced DTD.
`java.lang.String` `toString()` This returns a `String` representation of the `DocType`, suitable for debugging.

Methods inherited from class java.lang.Object
`finalize, getClass, notify, notifyAll, wait, wait, wait`

Field Detail

### elementName

    protected java.lang.String elementName

  The element being constrained

### publicID

    protected java.lang.String publicID

  The public ID of the DOCTYPE

### systemID

    protected java.lang.String systemID

  The system ID of the DOCTYPE

### document

    protected Document document

  The document having this DOCTYPE

### internalSubset

    protected java.lang.String internalSubset

  The internal subset of the DOCTYPE

Constructor Detail

### DocType

    protected DocType()

  Default, no-args constructor for implementations to use if needed.

### DocType

    public DocType(java.lang.String elementName,
                   java.lang.String publicID,
                   java.lang.String systemID)

  This will create the `DocType` with the specified element name and a reference to an external DTD.

  Parameters:
    `elementName` - `String` name of element being constrained.
    `publicID` - `String` public ID of referenced DTD
    `systemID` - `String` system ID of referenced DTD
  Throws:
    IllegalDataException - if the given system ID is not a legal system literal or the public ID is not a legal public ID.
    IllegalNameException - if the given root element name is not a legal XML element name.

### DocType

    public DocType(java.lang.String elementName,
                   java.lang.String systemID)

  This will create the `DocType` with the specified element name and reference to an external DTD.

  Parameters:
    `elementName` - `String` name of element being constrained.
    `systemID` - `String` system ID of referenced DTD
  Throws:
    IllegalDataException - if the given system ID is not a legal system literal.
    IllegalNameException - if the given root element name is not a legal XML element name.

### DocType

    public DocType(java.lang.String elementName)

  This will create the `DocType` with the specified element name

  Parameters:
    `elementName` - `String` name of element being constrained.
  Throws:
    IllegalNameException - if the given root element name is not a legal XML element name.

Method Detail

### getElementName

    public java.lang.String getElementName()

  This will retrieve the element name being constrained.

  Returns:
    `String` - element name for DOCTYPE

### setElementName

    public DocType setElementName(java.lang.String elementName)

  This will set the root element name declared by this DOCTYPE declaration.

  Parameters:
    `elementName` - `String` name of root element being constrained.
  Returns:
    DocType `DocType` this DocType object
  Throws:
    IllegalNameException - if the given root element name is not a legal XML element name.

### getPublicID

    public java.lang.String getPublicID()

  This will retrieve the public ID of an externally referenced DTD, or an empty `String` if none is referenced.

  Returns:
    `String` - public ID of referenced DTD.

### setPublicID

    public DocType setPublicID(java.lang.String publicID)

  This will set the public ID of an externally referenced DTD.

  Returns:
    DocType `DocType` this DocType object
  Throws:
    IllegalDataException - if the given public ID is not a legal public ID.

### getSystemID

    public java.lang.String getSystemID()

  This will retrieve the system ID of an externally referenced DTD, or an empty `String` if none is referenced.

  Returns:
    `String` - system ID of referenced DTD.

### setSystemID

    public DocType setSystemID(java.lang.String systemID)

  This will set the system ID of an externally referenced DTD.

  Returns:
    systemID `String` system ID of referenced DTD.
  Throws:
    IllegalDataException - if the given system ID is not a legal system literal.

### getDocument

    public Document getDocument()

  This retrieves the owning ``Document`` for this DocType, or null if not a currently a member of a ``Document``.

  Returns:
    `Document` owning this DocType, or null.

### setDocument

    protected DocType setDocument(Document document)

  This sets the ``Document`` holding this doctype.

  Parameters:
    `DocType` - `Document` holding this doctype
  Returns:
    `Document` this `DocType` modified

### setInternalSubset

    public void setInternalSubset(java.lang.String newData)

  This sets the data for the internal subset.

  Parameters:
    `newData` - data for the internal subset, as a `String`.

### getInternalSubset

    public java.lang.String getInternalSubset()

  This returns the data for the internal subset

  Returns:
    `String` - the internal subset

### toString

    public java.lang.String toString()

  This returns a `String` representation of the `DocType`, suitable for debugging.

  Overrides:
    toString in class java.lang.Object
  Returns:
    `String` - information about the `DocType`

### equals

    public final boolean equals(java.lang.Object ob)

  This tests for equality of this `DocType` to the supplied `Object`.

  Overrides:
    equals in class java.lang.Object
  Parameters:
    `ob` - `Object` to compare to.
  Returns:
    `boolean` - whether the `DocType` is equal to the supplied `Object`.

### hashCode

    public final int hashCode()

  This returns the hash code for this `DocType`.

  Overrides:
    hashCode in class java.lang.Object
  Returns:
    `int` - hash code.

### clone

    public java.lang.Object clone()

  This will return a clone of this `DocType`.

  Overrides:
    clone in class java.lang.Object
  Returns:
    `Object` - clone of this `DocType`.

Copyright © 2002 Jason Hunter, Brett McLaughlin. All Rights Reserved.